﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Diagram;

namespace DemoPerformance
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            diagram1.Model.SizeToContent = true;
            this.diagram1.Model.BoundaryConstraintsEnabled = false;
            diagram1.BeginUpdate();
            diagram1.EventSink.Pause();
            diagram1.Model.EventSink.Pause();
            diagram1.Model.BridgeManager.Pause();
            diagram1.Model.HistoryManager.Pause();
           
            Syncfusion.Windows.Forms.Diagram.Ellipse e1 = new Syncfusion.Windows.Forms.Diagram.Ellipse(0, 0, 40, 40);
            e1.FillStyle.Color = Color.Brown;
            this.diagram1.Model.AppendChild(e1);


            //Populate nodes
             GenerateInnerLevelNodes(e1,50, 100);


            
            diagram1.Model.HistoryManager.Resume();
            diagram1.Model.BridgeManager.Resume();
            diagram1.Model.EventSink.Resume();
            diagram1.EventSink.Resume();
            diagram1.EndUpdate();
        }

        private void GenerateInnerLevelNodes(Ellipse e1, int maxSubNodes, int l)
        {
            Ellipse parentNode = e1;
            int m = 70;
            for (int j= 0 ; j<l; j++)
            {
                Ellipse e = null;
                int k = 50;
                
                for (int i = 0; i < maxSubNodes; i++)
                {
                    e = new Syncfusion.Windows.Forms.Diagram.Ellipse(k, m, 40 , 40 );
                    e.FillStyle.Color = Color.SkyBlue;
                    this.diagram1.Model.AppendChild(e);
                    //ConnectNodes(parentNode, e);
                    k = k + 50;
                                       
                }
                parentNode = e;
                 m= m + 70;
                
            }
            
        }

        private void ConnectNodes(Node parentNode, Node childNode)
        {
            if (parentNode != null && childNode != null)
            {
                LineConnector lConnector = new LineConnector(PointF.Empty, new PointF(0, 1));
                lConnector.HeadDecorator.DecoratorShape = DecoratorShape.Filled45Arrow;
                parentNode.CentralPort.TryConnect(lConnector.TailEndPoint);
                childNode.CentralPort.TryConnect(lConnector.HeadEndPoint);
                this.diagram1.Model.AppendChild(lConnector);
                this.diagram1.Model.SendToBack(lConnector);
            }
        }
    }
}
